## com.fasterxml.jackson.databind.deser
Class BeanDeserializer

    java.lang.Object
      com.fasterxml.jackson.databind.JsonDeserializer<T>
          com.fasterxml.jackson.databind.deser.std.StdDeserializer<Object>
              com.fasterxml.jackson.databind.deser.BeanDeserializerBase
                  com.fasterxml.jackson.databind.deser.BeanDeserializer

All Implemented Interfaces:
  ContextualDeserializer, ResolvableDeserializer

Direct Known Subclasses:
  ThrowableDeserializer

    public class BeanDeserializer

extends BeanDeserializerBase

Deserializer class that can deserialize instances of arbitrary bean objects, usually from JSON Object structs, but possibly also from simple types like String values.

Nested Class Summary

Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonDeserializer
`JsonDeserializer.None`

Field Summary

Fields inherited from class com.fasterxml.jackson.databind.deser.BeanDeserializerBase
`_anySetter, _backRefs, _beanProperties, _beanType, _classAnnotations, _delegateDeserializer, _externalTypeIdHandler, _ignorableProps, _ignoreAllUnknown, _injectables, _needViewProcesing, _nonStandardCreation, _objectIdReader, _propertyBasedCreator, _subDeserializers, _unwrappedPropertyHandler, _valueInstantiator, _vanillaProcessing`

Fields inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer
`_valueClass`

Constructor Summary
`protected` `BeanDeserializer(BeanDeserializerBase src)` Copy-constructor that can be used by sub-classes to allow copy-on-write styling copying of settings of an existing instance.
`protected` `BeanDeserializer(BeanDeserializerBase src, boolean ignoreAllUnknown)`
`` `BeanDeserializer(BeanDeserializerBase src, HashSet<String> ignorableProps)`
`protected` `BeanDeserializer(BeanDeserializerBase src, NameTransformer unwrapper)`
`` `BeanDeserializer(BeanDeserializerBase src, ObjectIdReader oir)`
`` `BeanDeserializer(BeanDeserializerBuilder builder, BeanDescription beanDesc, BeanPropertyMap properties, Map<String,SettableBeanProperty> backRefs, HashSet<String> ignorableProps, boolean ignoreAllUnknown, boolean hasViews)` Constructor used by `BeanDeserializerBuilder`.

Method Summary
`protected Object` `_deserializeUsingPropertyBased(com.fasterxml.jackson.core.JsonParser jp, DeserializationContext ctxt)` Method called to deserialize bean using "property-based creator": this means that a non-default constructor or factory method is called, and then possibly other setters.
`Object` `deserialize(com.fasterxml.jackson.core.JsonParser jp, DeserializationContext ctxt)` Main deserialization method for bean-based objects (POJOs).
`Object` `deserialize(com.fasterxml.jackson.core.JsonParser jp, DeserializationContext ctxt, Object bean)` Secondary deserialization method, called in cases where POJO instance is created as part of deserialization, potentially after collecting some or all of the properties to set.
`Object` `deserializeFromArray(com.fasterxml.jackson.core.JsonParser jp, DeserializationContext ctxt)`
`Object` `deserializeFromBoolean(com.fasterxml.jackson.core.JsonParser jp, DeserializationContext ctxt)` Method called to deserialize POJO value from a JSON boolean value (true, false)
`Object` `deserializeFromDouble(com.fasterxml.jackson.core.JsonParser jp, DeserializationContext ctxt)` Method called to deserialize POJO value from a JSON floating-point number.
`Object` `deserializeFromNumber(com.fasterxml.jackson.core.JsonParser jp, DeserializationContext ctxt)`
`Object` `deserializeFromObject(com.fasterxml.jackson.core.JsonParser jp, DeserializationContext ctxt)` General version used when handling needs more advanced features.
`protected Object` `deserializeFromObjectUsingNonDefault(com.fasterxml.jackson.core.JsonParser jp, DeserializationContext ctxt)`
`Object` `deserializeFromString(com.fasterxml.jackson.core.JsonParser jp, DeserializationContext ctxt)`
`protected Object` `deserializeUsingPropertyBasedWithExternalTypeId(com.fasterxml.jackson.core.JsonParser jp, DeserializationContext ctxt)`
`protected Object` `deserializeUsingPropertyBasedWithUnwrapped(com.fasterxml.jackson.core.JsonParser jp, DeserializationContext ctxt)`
`protected Object` `deserializeWithExternalTypeId(com.fasterxml.jackson.core.JsonParser jp, DeserializationContext ctxt)`
`protected Object` `deserializeWithExternalTypeId(com.fasterxml.jackson.core.JsonParser jp, DeserializationContext ctxt, Object bean)`
`protected Object` `deserializeWithObjectId(com.fasterxml.jackson.core.JsonParser jp, DeserializationContext ctxt)` Alternative deserialization method used when we expect to see Object Id; if so, we will need to ensure that the Id is seen before anything else, to ensure that it is available for solving references, even if JSON itself is not ordered that way.
`protected Object` `deserializeWithUnwrapped(com.fasterxml.jackson.core.JsonParser jp, DeserializationContext ctxt)` Method called when there are declared "unwrapped" properties which need special handling
`protected Object` `deserializeWithUnwrapped(com.fasterxml.jackson.core.JsonParser jp, DeserializationContext ctxt, Object bean)`
`protected Object` `deserializeWithView(com.fasterxml.jackson.core.JsonParser jp, DeserializationContext ctxt, Object bean, Class<?> activeView)`
`protected Object` `handlePolymorphic(com.fasterxml.jackson.core.JsonParser jp, DeserializationContext ctxt, Object bean, TokenBuffer unknownTokens)` Method called in cases where we may have polymorphic deserialization case: that is, type of Creator-constructed bean is not the type of deserializer itself.
`JsonDeserializer<Object>` `unwrappingDeserializer(NameTransformer unwrapper)` Method that will return deserializer instance that is able to handle "unwrapped" value instances If no unwrapped instance can be constructed, will simply return this object as-is.
`BeanDeserializer` `withIgnorableProperties(HashSet<String> ignorableProps)`
`BeanDeserializer` `withObjectIdReader(ObjectIdReader oir)`

Methods inherited from class com.fasterxml.jackson.databind.deser.BeanDeserializerBase

`_findSubclassDeserializer, _resolveInnerClassValuedProperty, _resolveManagedReferenceProperty, _resolveUnwrappedProperty, createContextual, creatorProperties, deserializeFromObjectId, deserializeWithType, findBackReference, findProperty, getBeanClass, getKnownPropertyNames, getObjectIdReader, getPropertyCount, getValueInstantiator, getValueType, handleUnknownProperties, handleUnknownProperty, hasProperty, hasViews, injectValues, isCachable, properties, resolve, wrapAndThrow, wrapAndThrow, wrapInstantiationProblem`

Methods inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer
`_parseBoolean, _parseBooleanFromNumber, _parseBooleanPrimitive, _parseByte, _parseDate, _parseDouble, _parseDoublePrimitive, _parseFloat, _parseFloatPrimitive, _parseInteger, _parseIntPrimitive, _parseLong, _parseLongPrimitive, _parseShort, _parseShortPrimitive, findDeserializer, getValueClass, isDefaultDeserializer, isDefaultKeyDeserializer, parseDouble`

Methods inherited from class com.fasterxml.jackson.databind.JsonDeserializer
`getEmptyValue, getNullValue`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### BeanDeserializer

    public BeanDeserializer(BeanDeserializerBuilder builder,
                            BeanDescription beanDesc,
                            BeanPropertyMap properties,
                            Map<String,SettableBeanProperty> backRefs,
                            HashSet<String> ignorableProps,
                            boolean ignoreAllUnknown,
                            boolean hasViews)

  Constructor used by `BeanDeserializerBuilder`.

### BeanDeserializer

    protected BeanDeserializer(BeanDeserializerBase src)

  Copy-constructor that can be used by sub-classes to allow copy-on-write styling copying of settings of an existing instance.

### BeanDeserializer

    protected BeanDeserializer(BeanDeserializerBase src,
                               boolean ignoreAllUnknown)

### BeanDeserializer

    protected BeanDeserializer(BeanDeserializerBase src,
                               NameTransformer unwrapper)

### BeanDeserializer

    public BeanDeserializer(BeanDeserializerBase src,
                            ObjectIdReader oir)

### BeanDeserializer

    public BeanDeserializer(BeanDeserializerBase src,
                            HashSet<String> ignorableProps)

Method Detail

### unwrappingDeserializer

    public JsonDeserializer<Object> unwrappingDeserializer(NameTransformer unwrapper)

  Description copied from class: `JsonDeserializer`
  Method that will return deserializer instance that is able to handle "unwrapped" value instances If no unwrapped instance can be constructed, will simply return this object as-is.

  Default implementation just returns 'this' indicating that no unwrapped variant exists

  Specified by:
    `unwrappingDeserializer` in class `BeanDeserializerBase`

### withObjectIdReader

    public BeanDeserializer withObjectIdReader(ObjectIdReader oir)

  Specified by:
    `withObjectIdReader` in class `BeanDeserializerBase`

### withIgnorableProperties

    public BeanDeserializer withIgnorableProperties(HashSet<String> ignorableProps)

  Specified by:
    `withIgnorableProperties` in class `BeanDeserializerBase`

### deserialize

    public final Object deserialize(com.fasterxml.jackson.core.JsonParser jp,
                                    DeserializationContext ctxt)
                             throws IOException,
                                    com.fasterxml.jackson.core.JsonProcessingException

  Main deserialization method for bean-based objects (POJOs).

  Specified by:
    `deserialize` in class `JsonDeserializer<Object>`
  Parameters:
    `jp` - Parsed used for reading JSON content
    `ctxt` - Context that can be used to access information about this deserialization activity.
  Returns:
    Deserializer value
  Throws:
    `IOException`
    `com.fasterxml.jackson.core.JsonProcessingException`

### deserialize

    public Object deserialize(com.fasterxml.jackson.core.JsonParser jp,
                              DeserializationContext ctxt,
                              Object bean)
                       throws IOException,
                              com.fasterxml.jackson.core.JsonProcessingException

  Secondary deserialization method, called in cases where POJO instance is created as part of deserialization, potentially after collecting some or all of the properties to set.

  Overrides:
    `deserialize` in class `JsonDeserializer<Object>`
  Throws:
    `IOException`
    `com.fasterxml.jackson.core.JsonProcessingException`

### deserializeFromObject

    public Object deserializeFromObject(com.fasterxml.jackson.core.JsonParser jp,
                                        DeserializationContext ctxt)
                                 throws IOException,
                                        com.fasterxml.jackson.core.JsonProcessingException

  General version used when handling needs more advanced features.

  Throws:
    `IOException`
    `com.fasterxml.jackson.core.JsonProcessingException`

### deserializeWithObjectId

    protected Object deserializeWithObjectId(com.fasterxml.jackson.core.JsonParser jp,
                                             DeserializationContext ctxt)
                                      throws IOException,
                                             com.fasterxml.jackson.core.JsonProcessingException

  Alternative deserialization method used when we expect to see Object Id; if so, we will need to ensure that the Id is seen before anything else, to ensure that it is available for solving references, even if JSON itself is not ordered that way. This may require buffering in some cases, but usually just a simple lookup to ensure that ordering is correct.

  Throws:
    `IOException`
    `com.fasterxml.jackson.core.JsonProcessingException`

### deserializeFromObjectUsingNonDefault

    protected Object deserializeFromObjectUsingNonDefault(com.fasterxml.jackson.core.JsonParser jp,
                                                          DeserializationContext ctxt)
                                                   throws IOException,
                                                          com.fasterxml.jackson.core.JsonProcessingException

  Throws:
    `IOException`
    `com.fasterxml.jackson.core.JsonProcessingException`

### deserializeFromString

    public Object deserializeFromString(com.fasterxml.jackson.core.JsonParser jp,
                                        DeserializationContext ctxt)
                                 throws IOException,
                                        com.fasterxml.jackson.core.JsonProcessingException

  Throws:
    `IOException`
    `com.fasterxml.jackson.core.JsonProcessingException`

### deserializeFromNumber

    public Object deserializeFromNumber(com.fasterxml.jackson.core.JsonParser jp,
                                        DeserializationContext ctxt)
                                 throws IOException,
                                        com.fasterxml.jackson.core.JsonProcessingException

  Throws:
    `IOException`
    `com.fasterxml.jackson.core.JsonProcessingException`

### deserializeFromDouble

    public Object deserializeFromDouble(com.fasterxml.jackson.core.JsonParser jp,
                                        DeserializationContext ctxt)
                                 throws IOException,
                                        com.fasterxml.jackson.core.JsonProcessingException

  Method called to deserialize POJO value from a JSON floating-point number.

  Throws:
    `IOException`
    `com.fasterxml.jackson.core.JsonProcessingException`

### deserializeFromBoolean

    public Object deserializeFromBoolean(com.fasterxml.jackson.core.JsonParser jp,
                                         DeserializationContext ctxt)
                                  throws IOException,
                                         com.fasterxml.jackson.core.JsonProcessingException

  Method called to deserialize POJO value from a JSON boolean value (true, false)

  Throws:
    `IOException`
    `com.fasterxml.jackson.core.JsonProcessingException`

### deserializeFromArray

    public Object deserializeFromArray(com.fasterxml.jackson.core.JsonParser jp,
                                       DeserializationContext ctxt)
                                throws IOException,
                                       com.fasterxml.jackson.core.JsonProcessingException

  Throws:
    `IOException`
    `com.fasterxml.jackson.core.JsonProcessingException`

### _deserializeUsingPropertyBased

    protected final Object _deserializeUsingPropertyBased(com.fasterxml.jackson.core.JsonParser jp,
                                                          DeserializationContext ctxt)
                                                   throws IOException,
                                                          com.fasterxml.jackson.core.JsonProcessingException

  Method called to deserialize bean using "property-based creator": this means that a non-default constructor or factory method is called, and then possibly other setters. The trick is that values for creator method need to be buffered, first; and due to non-guaranteed ordering possibly some other properties as well.

  Throws:
    `IOException`
    `com.fasterxml.jackson.core.JsonProcessingException`

### handlePolymorphic

    protected Object handlePolymorphic(com.fasterxml.jackson.core.JsonParser jp,
                                       DeserializationContext ctxt,
                                       Object bean,
                                       TokenBuffer unknownTokens)
                                throws IOException,
                                       com.fasterxml.jackson.core.JsonProcessingException

  Method called in cases where we may have polymorphic deserialization case: that is, type of Creator-constructed bean is not the type of deserializer itself. It should be a sub-class or implementation class; either way, we may have more specific deserializer to use for handling it.

  Parameters:
    `jp` - (optional) If not null, parser that has more properties to handle (in addition to buffered properties); if null, all properties are passed in buffer
  Throws:
    `IOException`
    `com.fasterxml.jackson.core.JsonProcessingException`

### deserializeWithView

    protected final Object deserializeWithView(com.fasterxml.jackson.core.JsonParser jp,
                                               DeserializationContext ctxt,
                                               Object bean,
                                               Class<?> activeView)
                                        throws IOException,
                                               com.fasterxml.jackson.core.JsonProcessingException

  Throws:
    `IOException`
    `com.fasterxml.jackson.core.JsonProcessingException`

### deserializeWithUnwrapped

    protected Object deserializeWithUnwrapped(com.fasterxml.jackson.core.JsonParser jp,
                                              DeserializationContext ctxt)
                                       throws IOException,
                                              com.fasterxml.jackson.core.JsonProcessingException

  Method called when there are declared "unwrapped" properties which need special handling

  Throws:
    `IOException`
    `com.fasterxml.jackson.core.JsonProcessingException`

### deserializeWithUnwrapped

    protected Object deserializeWithUnwrapped(com.fasterxml.jackson.core.JsonParser jp,
                                              DeserializationContext ctxt,
                                              Object bean)
                                       throws IOException,
                                              com.fasterxml.jackson.core.JsonProcessingException

  Throws:
    `IOException`
    `com.fasterxml.jackson.core.JsonProcessingException`

### deserializeUsingPropertyBasedWithUnwrapped

    protected Object deserializeUsingPropertyBasedWithUnwrapped(com.fasterxml.jackson.core.JsonParser jp,
                                                                DeserializationContext ctxt)
                                                         throws IOException,
                                                                com.fasterxml.jackson.core.JsonProcessingException

  Throws:
    `IOException`
    `com.fasterxml.jackson.core.JsonProcessingException`

### deserializeWithExternalTypeId

    protected Object deserializeWithExternalTypeId(com.fasterxml.jackson.core.JsonParser jp,
                                                   DeserializationContext ctxt)
                                            throws IOException,
                                                   com.fasterxml.jackson.core.JsonProcessingException

  Throws:
    `IOException`
    `com.fasterxml.jackson.core.JsonProcessingException`

### deserializeWithExternalTypeId

    protected Object deserializeWithExternalTypeId(com.fasterxml.jackson.core.JsonParser jp,
                                                   DeserializationContext ctxt,
                                                   Object bean)
                                            throws IOException,
                                                   com.fasterxml.jackson.core.JsonProcessingException

  Throws:
    `IOException`
    `com.fasterxml.jackson.core.JsonProcessingException`

### deserializeUsingPropertyBasedWithExternalTypeId

    protected Object deserializeUsingPropertyBasedWithExternalTypeId(com.fasterxml.jackson.core.JsonParser jp,
                                                                     DeserializationContext ctxt)
                                                              throws IOException,
                                                                     com.fasterxml.jackson.core.JsonProcessingException

  Throws:
    `IOException`
    `com.fasterxml.jackson.core.JsonProcessingException`

Copyright © 2012 fasterxml.com. All Rights Reserved.